package dev.shadowsoffire.apotheosis.adventure.commands;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.brigadier.arguments.ArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.suggestion.SuggestionProvider;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import java.util.concurrent.CompletableFuture;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.commands.SharedSuggestionProvider;
import net.minecraft.commands.arguments.ResourceLocationArgument;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.item.ItemStack;

public class RarityCommand {
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_RARITY;
  
  static {
    SUGGEST_RARITY = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(RarityRegistry.INSTANCE.getKeys().stream().map(ResourceLocation::toString), builder));
  }
  
  public static void register(LiteralArgumentBuilder<CommandSourceStack> root) {
    root.then(((LiteralArgumentBuilder)Commands.m_82127_("set_rarity").requires(c -> c.m_6761_(2))).then(Commands.m_82129_("rarity", (ArgumentType)ResourceLocationArgument.m_106984_()).suggests(SUGGEST_RARITY).executes(c -> {
              ServerPlayer serverPlayer = ((CommandSourceStack)c.getSource()).m_81375_();
              LootRarity rarity = (LootRarity)RarityRegistry.INSTANCE.getValue(ResourceLocationArgument.m_107011_(c, "rarity"));
              ItemStack stack = serverPlayer.m_21205_();
              AffixHelper.setRarity(stack, rarity);
              return 0;
            })));
  }
}
